 /* Macros to swap the order of bytes in 16-bit integer values.
   Copyright  2012-2014 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or  any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   .  */

#ifndef _BITS_BYTESWAP_H
# error "Never use  directly; include  instead."
#endif

#ifdef __GNUC__
# if __GNUC__ >= 2
#  define __bswap_16 \
     __extension__							      \
       unsigned short int __v, __x =  ;	      \
	 if 				      \
	   __v = __bswap_constant_16 ;				      \
	 else								      \
	   __asm__ "rorw $8, %w0"					      \
		    : "=r" 					      \
		    : "0" 						      \
		    : "cc";						      \
	 __v; 
# else
/* This is better than nothing.  */
#  define __bswap_16 \
     
# endif
#else
static __inline unsigned short int
__bswap_16 

#endif
 