 /* Macros to swap the order of bytes in integer values.
   Copyright  1997-2014 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or  any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   .  */

#if !defined _BYTESWAP_H && !defined _NETINET_IN_H && !defined _ENDIAN_H
# error "Never use  directly; include  instead."
#endif

#ifndef _BITS_BYTESWAP_H
#define _BITS_BYTESWAP_H 1

#pragma "/usr/include/features.h"
#include "features.h"
#pragma "/usr/include/x86_64-linux-gnu/bits/types.h"
#include "types.h"
#pragma "/usr/include/x86_64-linux-gnu/bits/wordsize.h"
#include "wordsize.h"

/* Swap bytes in 16 bit value.  */
#define __bswap_constant_16 \
     

/* Get __bswap_16.  */
#pragma "/usr/include/x86_64-linux-gnu/bits/byteswap-16.h"
#include "byteswap-16.h"

/* Swap bytes in 32 bit value.  */
#define __bswap_constant_32 \
      |  |		      \
       | 

#ifdef __GNUC__
# if __GNUC_PREREQ 
static __inline unsigned int
__bswap_32 
;
# elif __GNUC__ >= 2
#  if __WORDSIZE == 64 || defined __i486__ || defined __pentium__	      \
			   || defined __pentiumpro__ || defined __pentium4__  \
			   || defined __k8__ || defined __athlon__	      \
			   || defined __k6__ || defined __nocona__	      \
			   || defined __core2__ || defined __geode__	      \
			   || defined __amdfam10__
/* To swap the bytes in a word the i486 processors and up provide the
   `bswap' opcode.  On i386 we have to use three instructions.  */
#   define __bswap_32 \
      __extension__							      \
        unsigned int __v, __x = ;					      \
	  if 				      \
	    __v = __bswap_constant_32 ;				      \
	  else								      \
	    __asm__ ;		      \
	  __v; 
#  else
#   define __bswap_32						      \
      __extension__							      \
        unsigned int __v, __x = ;					      \
	  if 				      \
	    __v = __bswap_constant_32 ;				      \
	  else								      \
	    __asm__ "rorw $8, %w0;"					      \
		     "rorl $16, %0;"					      \
		     "rorw $8, %w0"					      \
		     : "=r" 					      \
		     : "0" 					      \
		     : "cc";						      \
	  __v; 
#  endif
# else
#  define __bswap_32 \
     
# endif
#else
static __inline unsigned int
__bswap_32 

#endif


#if __GNUC_PREREQ (2, 0)
/* Swap bytes in 64 bit value.  */
# define __bswap_constant_64 \
     __extension__ 		      \
		     | 		      \
		     | 		      \
		     | 		      \
		     | 		      \
		     | 		      \
		     | 		      \
		     | 

# if __GNUC_PREREQ 
static __inline __uint64_t
__bswap_64 
;
# elif __WORDSIZE == 64
#  define __bswap_64 \
     __extension__							      \
       __uint64_t __v, __x = ;					      \
	 if 				      \
	   __v = __bswap_constant_64 ;				      \
	 else								      \
	   __asm__ ;		      \
	 __v; 
# else
#  define __bswap_64 \
     __extension__                                                           \
       union  __w, __r;                             \
	 if                                         \
	   __r.__ll = __bswap_constant_64 ;                                \
	 else                                                                 \
	                                                                     \
	     __w.__ll = ;                                                  \
	     __r.__l[0] = __bswap_32 ;                            \
	     __r.__l[1] = __bswap_32 ;                            \
	                                                                     \
	 __r.__ll; 
# endif
#else
# define __bswap_constant_64 \
     				      \
      | 				      \
      | 				      \
      | 				      \
      | 				      \
      | 				      \
      | 				      \
      | 

static __inline __uint64_t
__bswap_64 

#endif

#endif /* _BITS_BYTESWAP_H */
 