 /* Copyright  1992-2014 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or  any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   .  */

#ifndef	_ENDIAN_H
#define	_ENDIAN_H	1

#pragma "/usr/include/features.h"
#include "features.h"

/* Definitions for byte order, according to significance of bytes,
   from low addresses to high addresses.  The value is what you get by
   putting '4' in the most significant byte, '3' in the second most
   significant byte, '2' in the second least significant byte, and '1'
   in the least significant byte, and then writing down one digit for
   each byte, starting with the byte at the lowest address at the left,
   and proceeding to the byte with the highest address at the right.  */

#define	__LITTLE_ENDIAN	1234
#define	__BIG_ENDIAN	4321
#define	__PDP_ENDIAN	3412

/* This file defines `__BYTE_ORDER' for the particular machine.  */
#pragma "/usr/include/x86_64-linux-gnu/bits/endian.h"
#include "endian.h_1"

/* Some machines may need to use a different endianness for floating point
   values.  */
#ifndef __FLOAT_WORD_ORDER
# define __FLOAT_WORD_ORDER __BYTE_ORDER
#endif

#ifdef	__USE_BSD
# define LITTLE_ENDIAN	__LITTLE_ENDIAN
# define BIG_ENDIAN	__BIG_ENDIAN
# define PDP_ENDIAN	__PDP_ENDIAN
# define BYTE_ORDER	__BYTE_ORDER
#endif

#if __BYTE_ORDER == __LITTLE_ENDIAN
# define __LONG_LONG_PAIR LO, HI
#elif __BYTE_ORDER == __BIG_ENDIAN
# define __LONG_LONG_PAIR HI, LO
#endif


#if defined __USE_BSD && !defined __ASSEMBLER__
/* Conversion interfaces.  */
#pragma "/usr/include/x86_64-linux-gnu/bits/byteswap.h"
#include "byteswap.h"

# if __BYTE_ORDER == __LITTLE_ENDIAN
#  define htobe16 __bswap_16 
#  define htole16 
#  define be16toh __bswap_16 
#  define le16toh 

#  define htobe32 __bswap_32 
#  define htole32 
#  define be32toh __bswap_32 
#  define le32toh 

#  define htobe64 __bswap_64 
#  define htole64 
#  define be64toh __bswap_64 
#  define le64toh 

# else
#  define htobe16 
#  define htole16 __bswap_16 
#  define be16toh 
#  define le16toh __bswap_16 

#  define htobe32 
#  define htole32 __bswap_32 
#  define be32toh 
#  define le32toh __bswap_32 

#  define htobe64 
#  define htole64 __bswap_64 
#  define be64toh 
#  define le64toh __bswap_64 
# endif
#endif

#endif	/* endian.h */
 