 /* Definitions for POSIX 1003.1b-1993  scheduling interface.
   Copyright  1996-2014 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or  any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   .  */

#ifndef	_SCHED_H
#define	_SCHED_H	1

#pragma "/usr/include/features.h"
#include "features.h"

/* Get type definitions.  */
#pragma "/usr/include/x86_64-linux-gnu/bits/types.h"
#include "types.h"

#define __need_size_t
#pragma "/home/regehr/z/compiler-install/gcc-r231221-install/lib/gcc/x86_64-pc-linux-gnu/6.0.0/include/stddef.h"
#include "stddef.h"

#define __need_time_t
#define __need_timespec
#pragma "/usr/include/time.h"
#include "time.h"

#ifndef __pid_t_defined
typedef __pid_t pid_t;
# define __pid_t_defined
#endif


/* Get system specific constant and data structure definitions.  */
#pragma "/usr/include/x86_64-linux-gnu/bits/sched.h"
#include "sched.h_1"
/* Define the real names for the elements of `struct sched_param'.  */
#define sched_priority	__sched_priority


__BEGIN_DECLS

/* Set scheduling parameters for a process.  */
extern int sched_setparam 
     __THROW;

/* Retrieve scheduling parameters for a particular process.  */
extern int sched_getparam  __THROW;

/* Set scheduling algorithm and/or parameters for a process.  */
extern int sched_setscheduler  __THROW;

/* Retrieve scheduling algorithm for a particular purpose.  */
extern int sched_getscheduler  __THROW;

/* Yield the processor.  */
extern int sched_yield  __THROW;

/* Get maximum priority value for a scheduler.  */
extern int sched_get_priority_max  __THROW;

/* Get minimum priority value for a scheduler.  */
extern int sched_get_priority_min  __THROW;

/* Get the SCHED_RR interval for the named process.  */
extern int sched_rr_get_interval  __THROW;


#ifdef __USE_GNU
/* Access macros for `cpu_set'.  */
# define CPU_SETSIZE __CPU_SETSIZE
# define CPU_SET	 __CPU_SET_S 
# define CPU_CLR	 __CPU_CLR_S 
# define CPU_ISSET __CPU_ISSET_S 
# define CPU_ZERO	 __CPU_ZERO_S 
# define CPU_COUNT	 __CPU_COUNT_S 

# define CPU_SET_S   __CPU_SET_S 
# define CPU_CLR_S   __CPU_CLR_S 
# define CPU_ISSET_S __CPU_ISSET_S 
# define CPU_ZERO_S	    __CPU_ZERO_S 
# define CPU_COUNT_S	    __CPU_COUNT_S 

# define CPU_EQUAL \
  __CPU_EQUAL_S 
# define CPU_EQUAL_S \
  __CPU_EQUAL_S 

# define CPU_AND \
  __CPU_OP_S 
# define CPU_OR \
  __CPU_OP_S 
# define CPU_XOR \
  __CPU_OP_S 
# define CPU_AND_S \
  __CPU_OP_S 
# define CPU_OR_S \
  __CPU_OP_S 
# define CPU_XOR_S \
  __CPU_OP_S 

# define CPU_ALLOC_SIZE __CPU_ALLOC_SIZE 
# define CPU_ALLOC __CPU_ALLOC 
# define CPU_FREE __CPU_FREE 


/* Set the CPU affinity for a task */
extern int sched_setaffinity  __THROW;

/* Get the CPU affinity for a task */
extern int sched_getaffinity  __THROW;
#endif

__END_DECLS

#endif /* sched.h */
 