 /* __sig_atomic_t, __sigset_t, and related definitions.  Linux version.
   Copyright  1991-2014 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or  any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   .  */

#ifndef	_SIGSET_H_types
# define _SIGSET_H_types	1

typedef int __sig_atomic_t;

/* A `sigset_t' has a bit for each signal.  */

# define _SIGSET_NWORDS	
typedef struct
   __sigset_t;

#endif


/* We only want to define these functions if  was actually
   included; otherwise we were included just to define the types.  Since we
   are namespace-clean, it wouldn't hurt to define extra macros.  But
   trouble can be caused by functions being defined .  */

#if !defined _SIGSET_H_fns && defined _SIGNAL_H
# define _SIGSET_H_fns 1

# ifndef _EXTERN_INLINE
#  define _EXTERN_INLINE __extern_inline
# endif

/* Return a mask that includes the bit for SIG only.  */
# define __sigmask \
  

/* Return the word index for SIG.  */
# define __sigword	

# if defined __GNUC__ && __GNUC__ >= 2
#  define __sigemptyset \
  __extension__  int __cnt = _SIGSET_NWORDS;				      \
		    sigset_t *__set = ;				      \
		    while  __set->__val[__cnt] = 0;	      \
		    0; 
#  define __sigfillset \
  __extension__  int __cnt = _SIGSET_NWORDS;				      \
		    sigset_t *__set = ;				      \
		    while  __set->__val[__cnt] = ~0UL;	      \
		    0; 

#  ifdef __USE_GNU
/* The POSIX does not specify for handling the whole signal set in one
   command.  This is often wanted and so we define three more functions
   here.  */
#   define __sigisemptyset \
  __extension__  int __cnt = _SIGSET_NWORDS;				      \
		    const sigset_t *__set = ;			      \
		    int __ret = __set->__val[--__cnt];			      \
		    while 			      \
			__ret = __set->__val[__cnt];			      \
		    __ret == 0; 
#   define __sigandset \
  __extension__  int __cnt = _SIGSET_NWORDS;				      \
		    sigset_t *__dest = ;				      \
		    const sigset_t *__left = ;			      \
		    const sigset_t *__right = ;			      \
		    while 				      \
		      __dest->__val[__cnt] = ;	      \
		    0; 
#   define __sigorset \
  __extension__  int __cnt = _SIGSET_NWORDS;				      \
		    sigset_t *__dest = ;				      \
		    const sigset_t *__left = ;			      \
		    const sigset_t *__right = ;			      \
		    while 				      \
		      __dest->__val[__cnt] = ;	      \
		    0; 
#  endif
# endif

/* These functions needn't check for a bogus signal number -- error
   checking is done in the non __ versions.  */

extern int __sigismember ;
extern int __sigaddset ;
extern int __sigdelset ;

# ifdef __USE_EXTERN_INLINES
#  define __SIGSETFN					      \
  _EXTERN_INLINE int							      \
  NAME 				      \
  									      \
    unsigned long int __mask = __sigmask ;			      \
    unsigned long int __word = __sigword ;			      \
    return BODY;							      \
  

__SIGSETFN 
__SIGSETFN 
__SIGSETFN 

#  undef __SIGSETFN
# endif


#endif /* ! _SIGSET_H_fns.  */
 